#ifndef TYPETRAITS_INC_
#define TYPETRAITS_INC_

#include "Typelist.h"

namespace TypeTraits
{
    // Enumerate all primitive types
    typedef TYPELIST_14(
            const bool,
            const char,
            const signed char, 
            const unsigned char,
            const wchar_t,
            const short int, 
            const unsigned short int,
            const int,
            const unsigned int,
            const long int, 
            const unsigned long int,
            const float,
            const double,
            const long double)
        PrimitiveTypes;

    template <typename T> struct IsPrimitive
    {
        enum { value = Loki::TL::IndexOf<PrimitiveTypes, const T>::value > 0 };
    };

    template <typename T> struct IsPrimitive<T*>
    {
        enum { value = true };
    };

    template <typename T> struct CopyThrows
    {
        enum { value = !IsPrimitive<T>::value };
    };
}

#endif TYPETRAITS_INC_ 